// Made With Flow.
//
// DO NOT MODIFY, your changes will be lost when this file is regenerated.
//

import UIKit

public class ShrinkRotateTimeline: Timeline {
    public var view: SceneView

    public init() {
        view = SceneView()
    }

    public init(view: SceneView) {
        self.view = view
    }

    public func reset() {
        let view = self.view
        CATransaction.suppressAnimations() { 
            // reset rectangle
            view.rectangle.layer.removeAllAnimations()
            view.rectangle.shapeLayer.fillColor = UIColor(red: 0.077, green: 0.195, blue: 0.962, alpha: 1).cgColor
            view.rectangle.shapeLayer.strokeColor = UIColor(red: 0.909, green: 0.199, blue: 0.471, alpha: 1).cgColor
            view.rectangle.shapeLayer.bounds.size.width = 100
            view.rectangle.shapeLayer.bounds.size.height = 100
            view.rectangle.path = CGPathCreateWithSVGString("M0,100c0,0,100,0,100,0 0,0,0,-100,0,-100 0,0,-100,0,-100,0 0,0,0,100,0,100zM0,100")
            view.rectangle.setTransform(scaleX: 1, scaleY: 1, rotationAngle: 0)
        }
    }

    public func animate() {
        let view = self.view
        Animation(delay: 0, duration: 0.4, curve: .easeInOut) {
            view.rectangle.shapeLayer.bounds.size.width = 28
            view.rectangle.shapeLayer.bounds.size.height = 28
            let rectanglePathAnimation = CABasicAnimation(keyPath: "path")
            rectanglePathAnimation.fromValue = CGPathCreateWithSVGString("M0,100c0,0,100,0,100,0 0,0,0,-100,0,-100 0,0,-100,0,-100,0 0,0,0,100,0,100zM0,100")
            rectanglePathAnimation.toValue = CGPathCreateWithSVGString("M0,28c0,0,28,0,28,0 0,0,0,-28,0,-28 0,0,-28,0,-28,0 0,0,0,28,0,28zM0,28")
            rectanglePathAnimation.configureOptions()
            view.rectangle.layer.add(rectanglePathAnimation, forKey: "path")
            view.rectangle.path = CGPathCreateWithSVGString("M0,28c0,0,28,0,28,0 0,0,0,-28,0,-28 0,0,-28,0,-28,0 0,0,0,28,0,28zM0,28")
        }.animate()
        Animation(delay: 0, duration: 1, curve: .easeInOut) {
            CATransaction.begin()
            let rectangleRotationAnimation = CABasicAnimation()
            rectangleRotationAnimation.fromValue = 0
            rectangleRotationAnimation.toValue = 12.5664
            rectangleRotationAnimation.configureOptions()
            CATransaction.setCompletionBlock {
                view.rectangle.layer.setValue(12.5664, forKeyPath: "transform.rotation.z")
            }
            view.rectangle.layer.add(rectangleRotationAnimation, forKey: "transform.rotation.z")
            CATransaction.commit()
            view.rectangle.shapeLayer.strokeColor = UIColor(red: 0.077, green: 0.195, blue: 0.962, alpha: 1).cgColor
            view.rectangle.shapeLayer.fillColor = UIColor(red: 0.909, green: 0.199, blue: 0.471, alpha: 1).cgColor
        }.animate()
        Animation(delay: 0.6, duration: 0.4, curve: .easeInOut) {
            view.rectangle.shapeLayer.bounds.size.width = 100
            view.rectangle.shapeLayer.bounds.size.height = 100
            let rectanglePathAnimation = CABasicAnimation(keyPath: "path")
            rectanglePathAnimation.fromValue = CGPathCreateWithSVGString("M0,28c0,0,28,0,28,0 0,0,0,-28,0,-28 0,0,-28,0,-28,0 0,0,0,28,0,28zM0,28")
            rectanglePathAnimation.toValue = CGPathCreateWithSVGString("M0,100c0,0,100,0,100,0 0,0,0,-100,0,-100 0,0,-100,0,-100,0 0,0,0,100,0,100zM0,100")
            rectanglePathAnimation.configureOptions()
            view.rectangle.layer.add(rectanglePathAnimation, forKey: "path")
            view.rectangle.path = CGPathCreateWithSVGString("M0,100c0,0,100,0,100,0 0,0,0,-100,0,-100 0,0,-100,0,-100,0 0,0,0,100,0,100zM0,100")
        }.animate()
    }
}
